#!/bin/env python
# -*- coding: utf-8 -*-

from random import *
from time import *
from graph import *

graph_output = 1
# 隣接行列を出力する : 1 / しない : 0

print u"ランダムなグラフの幅優先探索木を求めます。"
print u"グラフの頂点数を入力してください。"
n = input()
print u"辺の割合を入力してください。"
rate = input()

print u"グラフ作成中 ..."
t0 = time()
g = RandomGraph(n, rate)
t1 = time()

if graph_output:
	WriteGraph(g)
print u"グラフ作成時間 =", t1 - t0


print u"探索中 ..."
t0 = time()
t, p = BFSTree(g, 0)
t1 = time()

if graph_output:
	WriteGraph(t)
print p
print u"頂点数 =", n
print u"辺数 =", CountEdges(g)
print u"探索時間 =", t1 - t0


