#!/bin/env python
# -*- coding: utf-8 -*-

from random import *
from time import *
from graph import *

graph_output = 1
# 隣接行列を出力するときは 1 に

print u"ランダムなグラフを連結成分に分解します。"
print u"グラフの頂点数を入力してください。"
n = input()
print u"辺の割合を入力してください。"
rate = input()

print u"グラフ作成中 ..."
g = RandomGraph(n, rate)
if graph_output:
	WriteGraph(g)

print u"分解中 ..."
t0 = time()
k, o, v = ConnectedDecompose(g)
t1 = time()


print u"頂点数 =", n
print u"辺数 =", CountEdges(g)
print k
print o
print v
print u"分解時間 =", t1 - t0


