#!/bin/env python
# -*- coding: utf-8 -*-

from random import *
from time import *
from graph import *

graph_output = 1
# 隣接行列を出力する : 1 / しない : 0

print u"ランダムなオイラーグラフを求めます。"
print u"グラフの頂点数を入力してください。"
n = input()
print u"辺の割合を入力してください。"
rate = input()

print u"グラフ作成中 ..."
t0 = time()
g = RandomEulerianGraph(n, rate)
t1 = time()

if graph_output:
	WriteGraph(g)
print u"グラフ作成時間 =", t1 - t0

print u"オイラーサーキット探索中 ..."
t0 = time()
ans = EulerianCircuit(g)
t1 = time()

print ans
print u"探索時間 =", t1 - t0
    

