#!/bin/env python
# -*- coding: utf-8 -*-
#
# MaxMatchWB.py

from random import *
from time import *
from graph import *

graph_output = 1
# 隣接行列を出力する : 1 / しない : 0

print u"ランダムな重み付き二部グラフの最大マッチングを求めます。"
print u"第１群の頂点数を入力してください。"
m = input()
print u"第２群の頂点数を入力してください。"
n = input()
print u"辺の割合を入力してください。"
rate = input()
"""

m = 4
n = 3
rate = 1.0
g = Graph(7)
g.wt = 1
g.size = 12
g.adj = [[0,0,0,0,2,8,10],
         [0,0,0,0,1,6,10],
         [0,0,0,0,6,10,6],
         [0,0,0,0,9,4,10],
         [2,1,6,9,0,0,0],
         [8,6,10,4,0,0,0],
         [10,10,6,10,0,0,0]]
g.v1 = range(4)
g.v2 = range(4,7)

"""

print u"グラフ作成中 ..."
t0 = time()
g = RandomWeightedBipartiteGraph(m, n, rate, 10)
t1 = time()

if graph_output:
	WriteGraph(g)
print u"グラフ作成時間 =", t1 - t0

t0 = time()
print u"計算中 ..."
vl, m = MaxMatchingWeightedBipartite(g)
t1 = time()

print u"最大マッチングの重み = ", vl
if graph_output:
        print u"最大マッチング:"
        WriteGraph(m)
print u"計算時間 =", t1 - t0




