#!/bin/env python
# -*- coding: utf-8 -*-
#
# testChromatic.py

from random import *
from time import *
from graph import *
from pol import *
from chr_pol import *

graph_output = 0
# 出力する : 1 / しない : 0

def experiment(n):
    for m in range(1, 21):
        g = RandomGraphOfGivenSize(n, m)
        if m <= 25:
            t0 = time()
            [k, f, remainfactor, linearfactors] = ChromaticInformation(g)
            t1 = time()
            if graph_output:
                print u"彩色数 =", k
                print u"彩色多項式 =",
                polwriteln(f)
                print u"　　　　　 =",
                for i in range(0, len(linearfactors)):
                    if i > 0:
                        if linearfactors[i] > 1:
                            print u" * (x - %d)^%d" % (i, linearfactors[i]),
                        else:
                            print u" * (x - %d)" % i,
                    else:
                        if linearfactors[0] > 1:
                            print u"x^%d" % linearfactors[0],
                        else:
                            print u"x",
                if poldeg(remainfactor) > 0: 
                    print u" * (",
                    polwrite(remainfactor),
                    print u")",
                print

            print u"頂点数 = %2d," % n,
            print u"辺数 = %2d," % m,
            print u"計算時間 =", t1 - t0

experiment(10)
experiment(11)
experiment(12)
experiment(13)
experiment(14)
experiment(15)



