#!/bin/env python
# -*- coding: utf-8 -*-
#
# Chromatic.py

from random import *
from time import *
from graph import *
from pol import *
from chr_pol import *

graph_output = 1
# 隣接行列を出力する : 1 / しない : 0

"""
g =CompleteGraph(5)
g = Cycle(7)
g = PetersenGraph()
g =CompleteBipartiteGraph(3,7)
"""

print u"ランダムなグラフの彩色多項式・彩色数を求めます。"
print u"グラフの頂点数を入力してください。"
n = input()
print u"辺数を入力してください。"
m = input()

print u"グラフ作成中 ..."
t0 = time()
g = RandomGraphOfGivenSize(n, m)
t1 = time()

if graph_output:
	WriteGraph(g)
print u"グラフ作成時間 =", t1 - t0

t0 = time()
print u"計算中 ..."
[k, f, remainfactor, linearfactors] = ChromaticInformation(g)
t1 = time()

print u"彩色数 =", k
print u"彩色多項式 =",
polwriteln(f)
print u"　　　　　 =",
for i in range(0, len(linearfactors)):
    if i > 0:
        if linearfactors[i] > 1:
            print u" * (x - %d)^%d" % (i, linearfactors[i]),
        else:
            print u" * (x - %d)" % i,
    else:
        if linearfactors[0] > 1:
            print u"x^%d" % linearfactors[0],
        else:
            print u"x",
        
if poldeg(remainfactor) > 0: 
    print u" * (",
    polwrite(remainfactor),
    print u")",
print

print u"頂点数 =", n
print u"辺数   =", CountEdges(g)
print u"計算時間 =", t1 - t0




