#!/bin/env python
# -*- coding: utf-8 -*-

from random import *
from time import *
from graph import *

graph_output = 1
# 隣接行列を出力する : 1 / しない : 0

print u"ランダムな重み付きグラフで最短路を求めます。"
print u"グラフの頂点数を入力してください。"
n = input()
print u"辺の割合を入力してください。"
rate = input()

print u"グラフ作成中 ..."
t0 = time()
g = RandomWeightedGraph(n, rate, 9)
t1 = time()

if graph_output:
	WriteGraph(g)
print u"グラフ作成時間 =", t1 - t0

u = 0
v = n - 1
print u"探索中 ..."
t0 = time()
ans = Dijkstra(g, u, v)
t1 = time()

if len(ans) > 1:
    d, p = ans
    print u"%d から %d への最短距離は %d" % (u, v, d)
    print u"最短路は", p
else:
    print u"%d から %d への道は存在しません。" % (u, v)
print u"探索時間 =", t1 - t0
    

