#!/bin/env python
# -*- coding: utf-8 -*-
#
# MaxFlow.py

from random import *
from time import *
from graph import *

graph_output = 1
# 隣接行列を出力する : 1 / しない : 0

print u"ランダムなネットワークの最大フローを求めます。"
print u"グラフの頂点数を入力してください。"
n = input()
print u"弧の割合を入力してください。"
rate = input()
u = 0
v = n - 1

print u"グラフ作成中 ..."
t0 = time()
g = RandomNetwork(n, u, v, rate, 32)
t1 = time()

if graph_output:
	WriteGraph(g)
print u"グラフ作成時間 =", t1 - t0

t0 = time()
print u"計算中 ..."
vl, mf = MaxFlow(g, u, v)
t1 = time()

print u"%d から %d への最大フローの値 = %d" % (u, v, vl)
if graph_output:
        print u"最大フロー："
        WriteGraph(mf)

print u"計算時間 =", t1 - t0




