#!/bin/env python
# -*- coding: utf-8 -*-
#
# MaxMatchB.py

from random import *
from time import *
from graph import *

graph_output = 1
# 隣接行列を出力する : 1 / しない : 0

"""
print u"ランダムな二部グラフの最大マッチングを求めます。"
print u"第１群の頂点数を入力してください。"
m = input()
print u"第２群の頂点数を入力してください。"
n = input()
print u"辺の割合を入力してください。"
rate = input()
"""

m = 4
n = 4
rate = 0.7

print u"グラフ作成中 ..."
t0 = time()
g = RandomBipartiteGraph(m, n, rate)
t1 = time()

if graph_output:
	WriteGraph(g)
print u"グラフ作成時間 =", t1 - t0

t0 = time()
print u"計算中 ..."
vl, m = MaxMatchingBipartite(g)
t1 = time()

print u"最大マッチングの辺数 = ", vl
if graph_output:
        print u"最大マッチング:"
        WriteGraph(m)
print u"計算時間 =", t1 - t0


t0 = time()
print u"計算中 ..."
vl, m = MaxMatching(g)
t1 = time()

print u"最大マッチングの辺数 = ", vl
if graph_output:
        print u"最大マッチング:"
        WriteGraph(m)

print u"計算時間 =", t1 - t0




