#!/bin/env python
# -*- coding: utf-8 -*-

from random import *
from time import *
from graph import *

graph_output = 1
# 隣接行列を出力する : 1 / しない : 0

for n in range(10, 101, 10):
    m = n * (n - 1) / 2
    print u"order =", n
    print u"size  =", m
    g = RandomWeightedGraph(n, 1, 10)
    if graph_output:
        WriteGraph(g)
    t0 = time()
    t = MinSpanningTree(g)
    t1 = time()
    if graph_output:
        WriteGraph(t)
    s = t1 - t0
    print u"最小連結子探索時間 s =", s
    print u"s / ( order ^ 4 ) =", (s / (n ** 4)) 

