#!/bin/env python
# -*- coding: utf-8 -*-
#
# testMaxFlow.py

from random import *
from time import *
from graph import *

graph_output = 0
# 隣接行列を出力する : 1 / しない : 0

for n in [500, 1000, 2000]:
        for m in [1, 2, 4, 8, 16]:
                rate = m * 2.0 / n
                u = 0
                v = n - 1
                g = RandomNetwork(n, u, v, rate, 32)
                t0 = time()
                vl, mf = MaxFlow(g, u, v)
                t1 = time()
                print u"頂点数 : %4d, " % n,
                print u"弧数 : %7d, " % CountArcs(g),
                print u"計算時間 =", t1 - t0
        print




